// Window class header
#pragma once

#include "nf/config.h"

#include <Windows.h>

namespace nf::client {
    class Window {
    public:
        Window(const char* windowTitle);

        HWND getHandle() const;
        void setDisplay(DisplayConfig& config);
        void runLoop();
        void show(bool show = true);

        ~Window();
    private:
        void registerWindowClass();
        static LRESULT CALLBACK wndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);
        SIZE getWindowSize();

        HWND m_handle;

        const char* m_wndClassName;
        const DWORD m_styleWindowed;
        const DWORD m_styleFullscreen;

        unsigned int m_currentWidth, m_currentHeight;
    };
}
